using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using RNGClassLibrary;
using System.Data.Entity;
using System.Data.SqlClient;


namespace RNGWcfService1.ContextClass
{
    public class DisposalEntryDbContext:DbContext
    {
        public DisposalEntryDbContext() : base()
        {
            Database.SetInitializer<DisposalEntryDbContext>(null);
            base.Database.Connection.ConnectionString = System.Configuration.ConfigurationManager.ConnectionStrings["RNGConnectionStrings"].ConnectionString;
        }

        public System.Data.Entity.DbSet<DisposalEntry> User { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Entity<DisposalEntry>().MapToStoredProcedures();
        }


        public void GetErrorDescription(int ErrorNo, ref string ErrorDesc)
        {
            var pErrCodeParam = new SqlParameter("pErrorNo", ErrorNo);

            var pErrDescParam = new SqlParameter("pErrorDesc", System.Data.SqlDbType.VarChar, 200);
            pErrDescParam.Direction = System.Data.ParameterDirection.Output;
            pErrDescParam.Value = "";

            this.Database.ExecuteSqlCommand("spErrors_GetErrorDesc @pErrorNo, @pErrorDesc out", pErrCodeParam, pErrDescParam);

            ErrorDesc = Convert.ToString(pErrDescParam.Value);
        }



        public virtual int DisposalEntry_AddNew(string UnitName, DateTime date, string item, string Qty, string Weight, string Remarks, DateTime CreatedDate, string IsActive, string UserID, string FinalYear, string Status, ref string errorDesc)
        {
            errorDesc = "";

            var ReturnValueParam = new SqlParameter("@ReturnValue", System.Data.SqlDbType.Int);
            ReturnValueParam.Direction = System.Data.ParameterDirection.Output;

            var paramUnitName = new SqlParameter("pUnitName", UnitName);
            var paramdate = new SqlParameter("pdate", date);
            var paramitem = new SqlParameter("pitem", item);
            var paramQty = new SqlParameter("pQty", Qty);
            var paramWeight = new SqlParameter("pWeight", Weight);
            var paramRemarks = new SqlParameter("pRemarks", Remarks);
            var paramCreatedDate = new SqlParameter("pCreatedDate", CreatedDate);
            var paramIsActive = new SqlParameter("pIsActive", IsActive);
            var paramUserID = new SqlParameter("pUserID", UserID);
            var paramFinalYear = new SqlParameter("pFinalYear", FinalYear);
            var paramStatus = new SqlParameter("pStatus", Status);



            var dbContext = this.Database;

            using (var dbContextTransaction = dbContext.BeginTransaction())
            {
                int errorNo = 0;

                try
                {
                    dbContext.ExecuteSqlCommand("Exec @ReturnValue = Sp_DisposalEntry_AddNew @pUnitName,@pdate,@pitem,@pQty,@pWeight,@pRemarks,@pCreatedDate,@pIsActive,@pUserID,@pFinalYear,@pStatus",
                                                ReturnValueParam, paramUnitName, paramdate, paramitem, paramQty, paramWeight, paramRemarks, paramCreatedDate, paramIsActive, paramUserID, paramFinalYear, paramStatus);

                    errorNo = Convert.ToInt32(ReturnValueParam.Value);

                    if (errorNo >= 0) //**** Success
                    {
                        dbContextTransaction.Commit();
                        this.SaveChanges();
                    }
                    else //**** Error ****
                    {
                        dbContextTransaction.Rollback();
                        GetErrorDescription(errorNo, ref errorDesc);
                    }
                }
                catch (Exception ex)
                {
                    dbContextTransaction.Rollback();

                    errorNo = -1;
                    errorDesc = Convert.ToString(ex.Message);
                }
                return errorNo;
            }
        }

        public virtual int DisposalEntry_Edit(int DisposalId, string UnitName, DateTime date, string item, string Qty, string Weight, string Remarks, string IsActive, string UserID, string FinalYear, string Status, ref string errorDesc)
        {
            errorDesc = "";

            var ReturnValueParam = new SqlParameter("@ReturnValue", System.Data.SqlDbType.Int);
            ReturnValueParam.Direction = System.Data.ParameterDirection.Output;

            var paramDisposalId = new SqlParameter("pDisposalId", DisposalId);
            var paramUnitName = new SqlParameter("pUnitName", UnitName);
            var paramdate = new SqlParameter("pdate", date);
            var paramitem = new SqlParameter("pitem", item);
            var paramQty = new SqlParameter("pQty", Qty);
            var paramWeight = new SqlParameter("pWeight", Weight);
            var paramRemarks = new SqlParameter("pRemarks", Remarks);

            var paramIsActive = new SqlParameter("pIsActive", IsActive);
            var paramUserID = new SqlParameter("pUserID", UserID);
            var paramFinalYear = new SqlParameter("pFinalYear", FinalYear);
            var paramStatus = new SqlParameter("pStatus", Status);



            var dbContext = this.Database;

            using (var dbContextTransaction = dbContext.BeginTransaction())
            {
                int errorNo = 0;

                try
                {
                    dbContext.ExecuteSqlCommand("Exec @ReturnValue = Sp_DisposalEntry_Edit @pDisposalId,@pUnitName,@pdate,@pitem,@pQty,@pWeight,@pRemarks,@pIsActive,@pUserID,@pFinalYear,@pStatus",
                                                ReturnValueParam,paramDisposalId,paramUnitName, paramdate, paramitem, paramQty, paramWeight, paramRemarks, paramIsActive, paramUserID, paramFinalYear, paramStatus);

                    errorNo = Convert.ToInt32(ReturnValueParam.Value);

                    if (errorNo >= 0) //**** Success
                    {
                        dbContextTransaction.Commit();
                        this.SaveChanges();
                    }
                    else //**** Error ****
                    {
                        dbContextTransaction.Rollback();
                        GetErrorDescription(errorNo, ref errorDesc);
                    }
                }
                catch (Exception ex)
                {
                    dbContextTransaction.Rollback();

                    errorNo = -1;
                    errorDesc = Convert.ToString(ex.Message);
                }
                return errorNo;
            }
        }



        public virtual List<DisposalEntry> DisposalEntry_GetAll(int DisposalId)
        {
            var paramDisposalId = new SqlParameter("pDisposalId", DisposalId);


            return this.Database.SqlQuery<DisposalEntry>(
                            "Sp_DisposalEntry_GetAll @pDisposalId",
                            paramDisposalId).ToList();
        }
    }
}